import Joi from 'joi';
import { Algorithm, AuthBaseToken } from './auth-base-token';
import { BaseIdToken } from './auth-type';
import { TokenKind } from '../type';
export type AuthIdRefreshTokenClaim = BaseIdToken & {
    uuid: string;
};
export declare const schemaAuthIdRefreshTokenClaim: {
    uuid: Joi.StringSchema<string>;
    userId: Joi.NumberSchema<number>;
    userLogin: Joi.StringSchema<string>;
    localeCode: Joi.StringSchema<string>;
    orgId: Joi.NumberSchema<number>;
    appDomain: Joi.StringSchema<string>;
    productId: Joi.NumberSchema<number>;
    extended: Joi.ObjectSchema<any>;
};
export declare class AuthIdRefreshToken extends AuthBaseToken<AuthIdRefreshTokenClaim> {
    private static self;
    private constructor();
    static init(secret: string, expiresIn: string | number, algorithm?: Algorithm): typeof AuthIdRefreshToken;
    static term(): void;
    static get instance(): AuthIdRefreshToken;
    static get isEnabled(): boolean;
    get expiresIn(): string | number;
    static decode(token: string, kind?: TokenKind): AuthIdRefreshTokenClaim;
}
