/// <reference types="node" />
import { KafkaProducer } from 'cm-libs-kafka';
import { DomainEventMessage } from 'cm-schema-event';
import { DomainEventCipher } from './domain-event-cipher';
import { Registry } from './domain-schema';
export declare function initDomainEventProducer<T = unknown, M = unknown>(schema?: string | Record<string, any>, metadataSchema?: string | Record<string, any>, topics?: string[], cipher?: DomainEventCipher, disableSchemaRegistry?: Registry | boolean | null): DomainEventProducer<T, M>;
export declare class DomainEventProducer<T = unknown, M = unknown> {
    private readonly config;
    readonly topics: string[];
    private producer;
    private domainEvent;
    constructor(config: string, topics: string[], schema?: string | Record<string, any>, metadataSchema?: string | Record<string, any>, cipher?: DomainEventCipher, disableSchemaRegistry?: Registry | boolean | null);
    term(): Promise<void>;
    publish(message: DomainEventMessage<T, M>, topic?: string): Promise<import("kafkajs").RecordMetadata[]>;
    publishRaw(encodedMessage: Buffer, messageKey?: string, topic?: string): Promise<import("kafkajs").RecordMetadata[]>;
    getProducer(): Promise<KafkaProducer>;
    get ready(): boolean;
    get schemaRegistryId(): number;
    get metadataSchemaRegistryId(): number;
}
