/// <reference types="node" />
import { SchemaRegistry } from '@kafkajs/confluent-schema-registry';
export declare class DomainSchema<T> {
    readonly schemaValue: string;
    private readonly schema;
    private registry;
    private _registryId;
    constructor(schema?: string | Record<string, any>, disableSchemaRegistry?: Registry | boolean | null);
    encode(value: T): Promise<Buffer>;
    decode(value: Buffer): Promise<T>;
    get isEnabled(): boolean;
    get isSchemaRegistryEnabled(): boolean;
    get registryId(): number;
}
export declare class Registry {
    private static self;
    private readonly url;
    private readonly overrides;
    api: SchemaRegistry;
    constructor(url: string, overrides?: any);
    static init(url: string, overrides?: any): Registry;
    static term(): void;
    clone(): Registry;
    static get instance(): Registry;
    static get isEnabled(): boolean;
}
