"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDeleteJoiSchema = exports.getAddJoiSchema = exports.getEditJoiSchema = exports.getReadJoiSchema = exports.getBrowseJoiSchema = exports._remark = exports._token = void 0;
const model_1 = require("../../common/model");
const joi_1 = __importDefault(require("joi"));
const lodash_1 = __importDefault(require("lodash"));
exports._token = joi_1.default.string();
exports._remark = joi_1.default.string();
function getBrowseJoiSchema(type, scalarFieldEnumSchema, orderByWithRelationInputSchemaObject) {
    return lodash_1.default.pick({
        distinct: joi_1.default.array().items(scalarFieldEnumSchema),
        where: joi_1.default.object(),
        pagination: model_1._pagination,
        orderBy: joi_1.default.array().items(joi_1.default.object(orderByWithRelationInputSchemaObject)),
        options: joi_1.default.object({
            speedMode: joi_1.default.boolean()
        }),
        include: joi_1.default.object(),
        select: joi_1.default.object()
    }, type);
}
exports.getBrowseJoiSchema = getBrowseJoiSchema;
function getReadJoiSchema(type, whereUniqueInputSchemaObject) {
    return lodash_1.default.pick({ where: joi_1.default.object(whereUniqueInputSchemaObject), select: joi_1.default.object(), include: joi_1.default.object() }, type);
}
exports.getReadJoiSchema = getReadJoiSchema;
function getEditJoiSchema(type, updateInputSchemaObject, whereUniqueInputSchemaObject) {
    return lodash_1.default.pick({ data: joi_1.default.object(updateInputSchemaObject), where: joi_1.default.object(whereUniqueInputSchemaObject), select: joi_1.default.object(), include: joi_1.default.object() }, type);
}
exports.getEditJoiSchema = getEditJoiSchema;
function getAddJoiSchema(type, addInputSchemaObject) {
    return lodash_1.default.pick({ data: joi_1.default.object(addInputSchemaObject), select: joi_1.default.object(), include: joi_1.default.object() }, type);
}
exports.getAddJoiSchema = getAddJoiSchema;
function getDeleteJoiSchema(type, whereUniqueInputSchemaObject) {
    return lodash_1.default.pick({ where: joi_1.default.object(whereUniqueInputSchemaObject), select: joi_1.default.object(), include: joi_1.default.object() }, type);
}
exports.getDeleteJoiSchema = getDeleteJoiSchema;
//# sourceMappingURL=joi.js.map