import Joi from 'joi';
import { AccessInfo } from '../auth';
export declare enum OrganizationAllow {
    PAIDChain = "PAIDChain",
    BANK = "BANK",
    APPLICANT = "APPLICANT"
}
export declare enum PAIDChainRole {
    MAKER = "MAKER",
    CHECKER = "CHECKER",
    APPROVER = "APPROVER",
    OFFICER = "OFFICER",
    MCH_MERCHANT_API = "MCH_MERCHANT_API"
}
export declare enum BankRole {
    MAKER = "MAKER",
    CHECKER = "CHECKER",
    APPROVER = "APPROVER",
    OFFICER = "OFFICER"
}
export declare enum Role {
    APPLICANT = "APPLICANT"
}
type AllRole = Role | PAIDChainRole | BankRole;
type functionArgs = {
    thisObject: any;
    fn: (request: any, info?: AccessInfo) => Promise<any>;
    schema: Joi.ObjectSchema;
    params: object;
    accessInfo?: AccessInfo;
};
export declare class Permission {
    private static readonly PAIDChainOrgCode;
    private static readonly BankOrgCode;
    private static readonly IS_BANK_INFRA;
    static readonly DISABLE_AUTH_CHECK: boolean;
    static check(organizationAllows: OrganizationAllow[], accessInfo: AccessInfo): Role | PAIDChainRole | BankRole;
    private static ApplicationCheck;
    private static PAIDChainCheck;
    private static BankCheck;
    static executeFunctionWithRole(actual: AllRole, expected: AllRole[] | AllRole, args: functionArgs[] | functionArgs): Promise<any>;
    private static loopEveryRoleAndCheck;
    static isBank(): boolean;
    static details(accessInfo: AccessInfo): {
        roleType: string;
        roleOrgCode: string;
        roleOrgId: number;
        remoteIp: string;
    };
}
export {};
